### CopyBelowMaterials.rb
### by Chanz - Based on DropVertices by TIG
require 'sketchup.rb'
###
module DAN
###
	def self.copymaterials()

	  model=Sketchup.active_model
	  ents=model.active_entities
	  
	  faces = ents.grep(Sketchup::Face)
		
	  faces.each {|x| 
	  
		rayt=model.raytest(find_centroid(x), Z_AXIS.reverse)
		if(rayt)

			rayt[1].each{|entity|
			
			if entity.class == Sketchup::Face
					#x.material = entity.material
					process_face(x, entity)
			end
			}
		end
	  }
	  
	  model.commit_operation

	  
	  begin
		model.start_operation("DAN.copymaterials", true)
	  rescue
		model.start_operation("DAN.copymaterials")
	  end
	end

	# Finds an adjusted point so we don't raycast down to an edge :)
	def self.find_centroid(face)
	  vertices=face.vertices
	  vertices[vertices.length]=vertices[0] ### =loop
	  centroid=Geom::Point3d.new()
	  a_sum=0.0
	  y_sum=0.0
	  x_sum=0.0
	  for i in (0...vertices.length-1)
		temp=(vertices[i].position.x*vertices[i+1].position.y)-(vertices[i+1].position.x*vertices[i].position.y)
		a_sum+=temp
		x_sum+=(vertices[i+1].position.x+vertices[i].position.x)*temp
		y_sum+=(vertices[i+1].position.y+vertices[i].position.y)*temp
	  end###for
	  ###area=a_sum/2
	  centroid.x=x_sum/(3*a_sum)
	  centroid.y=y_sum/(3*a_sum)
	  centroid.z=face.bounds.min.z
	  return centroid
	end
	
	#new stuff fixing UVs
	
	# face_one is in the model face_two is the one the raycast hit
	def self.process_face(face_one, face_two)
  
		# yes, I can create this outside and pass it in
		texture_writer=Sketchup.create_texture_writer
		
		if face_two.material.texture==nil 
			# no texture on the raycast hit! skip it.
		else
		
			# it looks like we are sampling the uvs from face two - which was hit in the raycast
			samples = []
			samples << face_two.vertices[0].position			   ### 0,0 | Origin
			samples << samples[0].offset(face_two.normal.axes.x) ### 1,0 | Offset Origin in X
			samples << samples[0].offset(face_two.normal.axes.y) ### 0,1 | Offset Origin in Y
			samples << samples[1].offset(face_two.normal.axes.y) ### 1,1 | Offset X in Y
			xyz = [];uv = []### Arrays containing 3D and UV points.
			uvh = face_two.get_UVHelper(true, true, texture_writer)
			samples.each { |position|
			xyz << position ### XYZ 3D coordinates
			
			# I switched this to front_UVQ
			uvq = uvh.get_front_UVQ(position) ### UV 2D coordinates
			uv << self.flattenUVQ(uvq)
			}
		  
			pts = [] ### Position texture.
			(0..3).each { |i|
			pts << xyz[i]
			pts << uv[i]
			}
		  
			# set the position and material of face_one
			mat = face_two.material
			face_one.position_material(mat, pts, true)


		end
	end
  
  ### Get UV coordinates from UVQ matrix.
  def self.flattenUVQ(uvq)
	return Geom::Point3d.new(uvq.x / uvq.z, uvq.y / uvq.z, 1.0)
  end
	
	#end new stuff
	
	
	###
	### menu
	unless file_loaded?(File.basename(__FILE__)) 
	  menu=UI.menu("Plugins").add_submenu("Copy Materials...")
	  menu.add_item("To Nearest Below"){DAN.copymaterials()}
	end
	file_loaded(File.basename(__FILE__)) 	

end